package net.sourceforge.orbroker;

import java.lang.reflect.Member;

/*
 * Created on Mar 25, 2004
 */

/**
 * Represents a member with arguments.
 * @author Nils Kilden-Pedersen
 */
abstract class ArgumentsMember extends ResultObjectMember {

	private ArgumentList argumentList;

	protected ArgumentsMember(Member member) {
		super(member);
	}
	
	protected void setArgumentList(ArgumentList parameterList) {
		assert this.argumentList == null:
			"Argument list has already been set.";
		this.argumentList = parameterList;
		this.argumentList.close();
	}

	protected void setParameter(ValueType valueType) {
		ArgumentList parmList = new ArgumentList(1);
		parmList.add(valueType);
		setArgumentList(parmList);
	}

	/**
	 * @return Returns argumentList.
	 */
	protected final ArgumentList getArgumentList() {
		return this.argumentList;
	}
}
