/*
 * Created on Oct 23, 2004
 */
package net.sourceforge.orbroker;

import java.text.DateFormat;
import java.text.FieldPosition;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Formatter;
import java.util.logging.LogRecord;

/**
 * @author Nils Kilden-Pedersen
 */
final class BrokerFormatter extends Formatter {

    private static final DateFormat DATE_FORMAT = new SimpleDateFormat("yyyy.MM.dd HH:mm:ss ");
    private static final String LINE_SEPARATOR = System.getProperty("line.separator");
    private static final FieldPosition START_POS = new FieldPosition(0);
    
    /**
     * @inheritDoc
     * @see java.util.logging.Formatter#format(java.util.logging.LogRecord)
     */
    public String format(LogRecord record) {
        StringBuffer buffer = new StringBuffer();
        DATE_FORMAT.format(new Date(record.getMillis()), buffer, START_POS);
        buffer.append(record.getLevel().toString()).append(": ");
        buffer.append(record.getMessage()).append(LINE_SEPARATOR);
        return  buffer.toString();
    }

}
