/*
 * Created on Oct 6, 2004
 */
package net.sourceforge.orbroker;

import java.util.logging.Level;


/**
 * @author Nils Kilden-Pedersen
 */
abstract class DynamicStatement extends Statement {

    /**
     * Constructor.
     * @param id
     * @param resultObjectDef
     */
    DynamicStatement(String id, ResultObjectDefinition resultObjectDef) {
        super(id, resultObjectDef);
    }

    protected BrokerException buildFailedParsingException(Exception e) {
        String msg = "Parsing of dynamic statement '" + getId() + "' failed.";
        return new BrokerException(msg, e);
    }
    
    protected void logBrokerStatement(StringBuffer buffer, Statement.Type type) {
	    if (Broker.isLoggable(Level.FINE)) {
	        StringBuffer message = new StringBuffer().append("Parsed ").append(type.toString());
	        message.append(" template statement '").append(this.getId()).append("' as:\n");
	        message.append(buffer);
	        Broker.log(Level.FINE,  message.toString());
	    }
    }

}
