/*
 * Created on Feb 26, 2005
 */
package net.sourceforge.orbroker;

import java.util.List;

/**
 * @author Nils Kilden-Pedersen
 */
final class ImmutableSQL {
	private final List parameterNames;
	private final String sqlStatement;
	
	ImmutableSQL(String sqlStatement, List parameterNames) {
		this.sqlStatement = sqlStatement;
		this.parameterNames = parameterNames;
	}
	
	String getSqlStatement() {
		return this.sqlStatement;
	}
	
	int getParameterCount() {
		return this.parameterNames.size();
	}
	
	String getParameterName(int index) {
		return (String) this.parameterNames.get(index);
	}
	
	boolean hasParameters() {
		return !this.parameterNames.isEmpty();
	}
	
	String[] copyParameterNames() {
		return (String[]) 
			this.parameterNames.toArray(new String[this.parameterNames.size()]);
	}
	
	/**
	 * @inheritDoc
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "SQL: " + getSqlStatement();
	}
}
