package net.sourceforge.orbroker;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.ListIterator;

/*
 * Created on Apr 20, 2004
 *
 */

/**
 * @author Nils Kilden-Pedersen
*/
final class LazyList extends LazyCollection implements List {

	LazyList(Broker broker, String statementID, ConnectionContext context) {
		super(broker, statementID, context, new ArrayList());
	}

	/**
	 * @see java.util.List#add(int, java.lang.Object)
	 */
	public void add(int index, Object object) {
		getList().add(index, object);
	}

	/**
	 * @see java.util.List#addAll(int, java.util.Collection)
	 */
	public boolean addAll(int index, Collection collection) {
		return getList().addAll(index, collection);
	}
	/**
	 * @see java.util.List#get(int)
	 */
	public Object get(int index) {
		return getList().get(index);
	}
	
	/**
	 * @see java.util.List#indexOf(java.lang.Object)
	 */
	public int indexOf(Object object) {
		return getList().indexOf(object);
	}

	/**
	 * @see java.util.List#lastIndexOf(java.lang.Object)
	 */
	public int lastIndexOf(Object object) {
		return getList().lastIndexOf(object);
	}

	/**
	 * @see java.util.List#listIterator()
	 */
	public ListIterator listIterator() {
		return getList().listIterator();
	}

	/**
	 * @see java.util.List#listIterator(int)
	 */
	public ListIterator listIterator(int index) {
		return getList().listIterator(index);
	}

	/**
	 * @see java.util.List#remove(int)
	 */
	public Object remove(int index) {
		return getList().remove(index);
	}

	/**
	 * @see java.util.List#set(int, java.lang.Object)
	 */
	public Object set(int index, Object object) {
		return getList().set(index, object);
	}

	/**
	 * @see java.util.List#subList(int, int)
	 */
	public List subList(int fromIndex, int toIndex) {
		return getList().subList(fromIndex, toIndex);
	}
	
	private List getList() {
		return (List) getCollection();
	}

}
