/*
 * Created on Oct 6, 2004
 */
package net.sourceforge.orbroker;

import java.util.Comparator;
import java.util.SortedSet;
import java.util.TreeSet;

/**
 * @author Nils Kilden-Pedersen
 */
final class LazySortedSet extends LazyCollection implements SortedSet {

    LazySortedSet(Broker broker, String statementID, ConnectionContext context) {
        super(broker, statementID, context, new TreeSet());
    }

    private SortedSet getSortedSet() {
        return (SortedSet) getCollection();
    }

    /**
     * @inheritDoc
     * @see java.util.SortedSet#first()
     */
    public Object first() {
        return getSortedSet().first();
    }

    /**
     * @inheritDoc
     * @see java.util.SortedSet#last()
     */
    public Object last() {
        return getSortedSet().last();
    }

    /**
     * @inheritDoc
     * @see java.util.SortedSet#comparator()
     */
    public Comparator comparator() {
        return getSortedSet().comparator();
    }

    /**
     * @inheritDoc
     * @see java.util.SortedSet#headSet(java.lang.Object)
     */
    public SortedSet headSet(Object toElement) {
        return getSortedSet().headSet(toElement);
    }

    /**
     * @inheritDoc
     * @see java.util.SortedSet#tailSet(java.lang.Object)
     */
    public SortedSet tailSet(Object fromElement) {
        return getSortedSet().tailSet(fromElement);
    }

    /**
     * @inheritDoc
     * @see java.util.SortedSet#subSet(java.lang.Object, java.lang.Object)
     */
    public SortedSet subSet(Object fromElement, Object toElement) {
        return getSortedSet().subSet(fromElement, toElement);
    }
}
