/*
 * Created on Dec 20, 2004
 */
package net.sourceforge.orbroker;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Nils Kilden-Pedersen
 */
class MapWith extends ValueType {

    private final ResultObjectDefinition resultObjectDef;
    private Map aliasColumns;
    
    /**
     * Constructor.
     * @param type
     * @param resultObjectDef
     */
    MapWith(ResultObjectDefinition resultObjectDef) {
        super(resultObjectDef.getType());
        this.resultObjectDef = resultObjectDef;
    }

    void addAlias(String mappedColumn, String queryColumn) {
        if (this.aliasColumns == null) {
            this.aliasColumns = new HashMap();
        }
        this.aliasColumns.put(mappedColumn, queryColumn);
    }
    
    /**
     * @inheritDoc
     * @see net.sourceforge.orbroker.ValueType#getValue(net.sourceforge.orbroker.ResultRow)
     */
    Object getValue(ResultRow row) throws BrokerException {
        row.pushAliases(this.aliasColumns);
        Object value = this.resultObjectDef.buildObject(row);
        row.pullAliases();
        return value;
    }

}
