/*
 * Created on Feb 23, 2004
 */
package net.sourceforge.orbroker;

import java.lang.reflect.Constructor;

import net.kildenpedersen.reflect.Reflector;


/**
 * @author Nils Kilden-Pedersen
 */
class ResultObjectConstructor extends ResultObjectInstantiator {
	
	private static Constructor buildConstructor(Class type, ArgumentList parameters) {
		parameters.close();
		Class[] parmClasses = parameters.getArgumentTypes();
		Constructor constructor = Reflector.getAccessibleConstructor(type, parmClasses); 
		if (constructor != null) {
		    return constructor;
		}
		String msg = 
			"Unknown constructor: " + 
			Reflector.getClassName(type) + 
			parameters.toString();
		throw new ConfigurationException(msg);
	}
	
	ResultObjectConstructor(Class type, ArgumentList parameters) {
		super(buildConstructor(type, parameters), parameters);
	}

	private Constructor getConstructor() {
		return (Constructor) getMember();
	}

	/**
	 * Get new instance.
	 * @param row
	 * @return result object
	 */
	Object newInstance(ResultRow row) {
		Object[] parmObjects = this.getArgumentList().getArgumentValues(row);
		try {
			return getConstructor().newInstance(parmObjects);
		} catch (Exception e) {
			String msg = "Cannot construct " + 
				Reflector.getClassName(getConstructor().getDeclaringClass());
			throw new ReflectionException(msg, e);
		}
	}

    /**
     * @inheritDoc
     * @see net.sourceforge.orbroker.ResultObjectInstantiator#copy(Class)
     */
    ResultObjectInstantiator copy(Class forType) {
        return new ResultObjectConstructor(forType, getArgumentList());
    }
}
