/*
 * Created on Feb 23, 2004
 */
package net.sourceforge.orbroker;

import java.lang.reflect.Member;

/**
 * @author Nils Kilden-Pedersen
 */
abstract class ResultObjectInstantiator extends ArgumentsMember {

	ResultObjectInstantiator(Member member, ArgumentList parameters) {
		super(member);
		super.setArgumentList(parameters);
	}

	/**
	 * Copy <code>this</code> for type.
	 * @param forType
	 * @return copy of this.
	 */
	abstract ResultObjectInstantiator copy(Class forType);

	/**
	 * Get new instance.
	 * 
	 * @param row
	 * @return result object
	 */
	abstract Object newInstance(ResultRow row);

	/**
	 * @inheritDoc
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return getMember().toString();
	}

}
