package net.sourceforge.orbroker;

import java.lang.reflect.Method;

import net.kildenpedersen.reflect.Reflector;


/*
 * Created on Mar 22, 2004
 */

/**
 * 
 * @author Nils Kilden-Pedersen
 */
final class SetProperty extends SetterMethod {
	
	/**
	 * Find the write method.
	 * @param roType The result-object type
	 * @param propertyName The set-property name 
	 * @return write method for property
	 */
	private static Method findWriteMethod(Class roType, String propertyName) {
	    Method writeMethod = Reflector.getAccessibleWriteProperty(roType, propertyName);
		if (writeMethod != null) {
		    return writeMethod;
		}
		String msg = "No setter for property '" +
			propertyName + "' found on class '" + Reflector.getClassName(roType) + "'";
		throw new ConfigurationException(msg);
	}

	/**
	 * Constructor
	 * @param resultObjectType The result-object type
	 * @param propertyName The set-property name 
	 */
	SetProperty(Class resultObjectType, String propertyName) {
		super(findWriteMethod(resultObjectType, propertyName));
	}
	
	/**
	 * Returns the property type.
	 * @return property type
	*/
	Class getPropertyType() {
		return getParameterTypes()[0];
	}
}