/*
 * Created on Feb 20, 2004
 */
package net.sourceforge.orbroker;



/**
 * @author Nils Kilden-Pedersen
 */
class StaticStatement extends Statement {

	private final SQLParser parser;
	
	StaticStatement(String id, String statement, ResultObjectDefinition resultObjectDef) throws ConfigurationException {
		super(id, resultObjectDef);
		this.parser = new SQLParser(new StringBuffer(statement));
	}

	/**
	 * @inheritDoc
	 * @see net.sourceforge.orbroker.Statement#getRunnableSQL(net.sourceforge.orbroker.ConnectionContext)
	 */
	ImmutableSQL getRunnableSQL(ConnectionContext context) throws BrokerException {
		return this.parser.getRunnableStatement(context.getTextReplacements());
	}

}