/*
 * Created on Dec 1, 2004
 */
package net.sourceforge.orbroker;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

/**
 * @author Nils Kilden-Pedersen
 */
final class TextReplacements {
    
    private static void checkValue(String value) {
    	if (value.indexOf('?') > -1) {
    		throw new ConfigurationException(
    				"Invalid text replacement. Cannot contain '?'.");
    	}
    }
    private final HashMap map = new HashMap(5);
    
    private void setAll(Map stringMap) {
        if (stringMap.isEmpty()) {
            return;
        }
        Iterator iter = stringMap.entrySet().iterator();
        while (iter.hasNext()) {
            Map.Entry entry = (Map.Entry) iter.next();
            String key = (String) entry.getKey();
            String value = (String) entry.getValue();
            setProperty(key, value);
        }
    }
    
    String getProperty(String key) {
        return (String) this.map.get(key);
    }
    
    void setAll(Properties props) {
        setAll((Map) props);
    }
    
    void setAll(TextReplacements props) {
        setAll(props.map);
    }
    
    void setProperty(String key, String value) {
        checkValue(value);
        this.map.put(key, value);
    }
    
    /**
     * @inheritDoc
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return this.map.toString();
    }
}
