package net.sourceforge.orbroker;

import java.util.ArrayList;
import java.util.List;

/*
 * Created on Mar 19, 2004
 */

/**
 * 
 * @author Nils Kilden-Pedersen
 */
abstract class TypedList {
	
	private boolean closed = false;
	private final List list;
	
	protected TypedList() {
		this.list = new ArrayList(); 
	}
	
	protected TypedList(int size) {
		this.list = new ArrayList(size);
	}
	/**
	 * Check if list has been closed. 
	 * Classes implementing an <code>add</code> method, 
	 * must call this method first. 
	 * @param object
	 */
	protected void add(Object object) {
		if (this.closed) {
			throw new IllegalStateException("List has been closed. Cannot add.");
		}
		this.list.add(object);
	}
	
	protected Object get(int index) {
		return this.list.get(index);
	}
	
	void close() {
		this.closed = true;
	}
	
	boolean isClosed() {
		return this.closed;
	}
	
	int size() {
		return this.list.size();
	}
	
	/**
	 * @inheritDoc
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return this.list.toString();
	}
}
