/*
 * Created on Sep 21, 2004
 */
package net.sourceforge.orbroker.exception;

import java.sql.SQLException;

/**
 * Interface to interrogate an {@link java.sql.SQLException}.
 * @author Nils Kilden-Pedersen
 * @see net.sourceforge.orbroker.Broker#setExceptionEvaluator(ExceptionEvaluator)
 */
public interface ExceptionEvaluator {

    /**
     * Is SQLException a constraint violation?
     * @param source Exception source
     * @return true, if SQLException is caused by a database constraint.
     */
    public boolean isConstraint(SQLException source);

    /**
     * Is SQLException a deadlock?
     * @param source Exception source
     * @return true, if SQLException is caused by a dead lock.
     */
public boolean isDeadlock(SQLException source);

/**
 * Is SQLException caused by stale connection?
 * @param source Exception source
 * @return true, if SQLException is caused by a stale connection.
 */
public boolean isStaleConnection(SQLException source);
}

