package net.sourceforge.orbroker.velocity;

import java.util.logging.Level;
import net.sourceforge.orbroker.Broker;

import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.log.LogSystem;

/**
 * Wrapper for Velocity logging.
 * @author Nils Kilden-Pedersen
 */
public class LogWrapper implements LogSystem {

	private static final Level[] logLevels = new Level[4];
	static {
		logLevels[LogSystem.DEBUG_ID] = Level.FINEST;
		logLevels[LogSystem.INFO_ID] = Level.FINER;
		logLevels[LogSystem.WARN_ID] = Level.WARNING;
		logLevels[LogSystem.ERROR_ID] = Level.SEVERE;
	}

	/**
	 * @see org.apache.velocity.runtime.log.LogSystem#init(org.apache.velocity.runtime.RuntimeServices)
	 */
	public void init(RuntimeServices rs) throws Exception {
		return;
	}

	/**
	 * @see org.apache.velocity.runtime.log.LogSystem#logVelocityMessage(int,
	 *          java.lang.String)
	 */
	public void logVelocityMessage(int level, String message) {
	    Broker.log(logLevels[level], message);
	}
}